'use client'

import { QueryClient, QueryClientProvider } from '@tanstack/react-query';
import { MantineProvider } from '@mantine/core';
import { KccbTheme } from './_themes/KccbTheme';
import { Notifications } from '@mantine/notifications';

const queryClient = new QueryClient();

export function Providers({ children }: { children: React.ReactNode }) {
    return (
        <MantineProvider theme={KccbTheme} defaultColorScheme='light'>
            <Notifications position='top-center' />
            <QueryClientProvider client={queryClient}>
                {/* <UserContextProvider> */}
                {children}
                {/* </UserContextProvider> */}
            </QueryClientProvider>
        </MantineProvider>
    )
}